void make_line_tile(BYTE nr,WORD offset)
{
 if(nr>143)
	 return;
 DWORD t_temp;
 if(offset>21)
  return;
 tc=offset;
 {
  WORD tilemap,tile_addr,w1,w2,w3;
  DWORD buff_addr=dx_bits*offset*8+100;
  BYTE tile_nr,attr,tile_fx;
  BYTE nr_y=(m_iram[0xff42]+nr);
  BYTE nr_x=m_iram[0xff43];
  WORD start_tiles=((nr_x>>3)+offset)&31;
  if(m_iram[0xff40]&8)
   tilemap=0x9c00;
  else
   tilemap=0x9800;
  tile_nr=m_iram[(tilemap+start_tiles+((nr_y&248)<<2))];
  attr=m_iram2[(tilemap+start_tiles+((nr_y&248)<<2))];
  if(m_iram[0xff40]&16)
  _asm
  {
   mov al,tile_nr
   movzx ax,al
   shl ax,4
   add ax,0x8000
   mov tile_addr,ax
  }
  else
  {
   _asm
   {
    mov al,tile_nr
    movsx ax,al
    sal ax,4
    add ax,0x9000
    mov tile_addr,ax
   }
  }
  if(attr&64)
   tile_addr+=(7-(nr_y-8*(nr_y>>3)))*2;
  else
   tile_addr+=(nr_y-8*(nr_y>>3))*2;
  if(!(attr&8))
  {
   w1=m_iram[tile_addr++];
   w2=m_iram[tile_addr];
  }
  else
  {
   w1=m_iram2[tile_addr++];
   w2=m_iram2[tile_addr];
  }
  if(attr&32)
   tile_fx=1;
  else 
   tile_fx=0;
  w3=(w2<<8)|w1;
  for(int lop=0;lop<8;lop++)
  {
   line_b_mask[buff_addr]=pix[w3][lop][tile_fx];
   {
    t_temp=pal_dx_b[attr&7][pix[w3][lop][tile_fx]];	
    switch(dx_bits)
	{
	 case 2: 
	  _asm
	  {
	   mov eax,t_temp
	   mov edi,buff_addr
	   mov word ptr line_b[edi],ax
	   lea edi,[edi+2]
	   mov buff_addr,edi
	  }
	  break;
	 case 3:
	  _asm
	  {
	   mov eax,t_temp
	   mov ebx,eax
	   shr eax,16
	   mov edi,buff_addr
	   mov line_b[edi],bl
	   mov line_b[edi+1],bh
	   mov line_b[edi+2],al
	   lea edi,[edi+3]
	   mov buff_addr,edi
	  }
	  break;
	 case 4:
	  _asm
	  {
	   mov eax,t_temp
	   mov edi,buff_addr
	   mov dword ptr line_b[edi],eax
	   lea edi,[edi+4]
	   mov buff_addr,edi
	  }
	  break;
	}
   }	
  }
  start_tiles++;
  start_tiles&=31;
 } 
}

void make_line_finish(BYTE nr)
{	
 WORD w1,w2,w3;
 DWORD t_temp;	
 if(nr>143)
  return;
 while(tc<20)
  make_line_tile(nr,tc+1);
 WORD window_line,window_start;
 WORD window_tile_map,temp_v,qpoi;
 DWORD buff_addr=0;
 BYTE tile_nr;
 BYTE attr;
 WORD tile_addr;
 BYTE tile_fx;
 BYTE nr_x=m_iram[0xff43];
 if((m_iram[0xff40]&32)&&(m_iram[0xff4a]<=nr))
 {
  window_line=nr-m_iram[0xff4a];
  temp_v=window_line>>3;
  window_start=0;
  if(m_iram[0xff40]&64)
   window_tile_map=0x9c00;
  else
   window_tile_map=0x9800;
  for(qpoi=0;qpoi<32;qpoi++)
  {
   tile_nr=m_iram[(window_tile_map+(temp_v<<5)+window_start)];
   attr=m_iram2[(window_tile_map+(temp_v<<5)+window_start)];
   if(m_iram[0xff40]&16)
    _asm
	{
     mov al,tile_nr
     movzx ax,al
     shl ax,4
	 add ax,0x8000
     mov tile_addr,ax
    }
   else
   _asm
   {
    mov al,tile_nr
    movsx ax,al
    sal ax,4
    add ax,0x9000
	mov tile_addr,ax
   }
   if(attr&64)
	tile_addr+=(7-(window_line-8*temp_v))*2;
   else
	tile_addr+=(window_line-8*temp_v)*2;
   if(!(attr&8))
   {
    w1=m_iram[tile_addr++];
    w2=m_iram[tile_addr];
   }
   else
   {
    w1=m_iram2[tile_addr++];
    w2=m_iram2[tile_addr];
   }
   w3=(w2<<8)|w1;
   if(attr&32)
	tile_fx=1;
   else 
	tile_fx=0;
   for(int lop=0;lop<8;lop++)
   {
	{
	t_temp=pal_dx_b[attr&7][pix[w3][lop][tile_fx]];	
	switch(dx_bits)
	{
	 case 2:
	  _asm
	  {
	   mov eax,t_temp
	   mov edi,buff_addr
	   mov word ptr window_b[edi],ax
	   lea edi,[edi+2]
	   mov buff_addr,edi
	  }
	  break;
	 case 3:
	  _asm
	  {
	   mov eax,t_temp
	   mov ebx,eax
	   shr eax,16
	   mov edi,buff_addr
	   mov window_b[edi],bl
	   mov window_b[edi+1],bh
	   mov window_b[edi+2],al
	   lea edi,[edi+3]
	   mov buff_addr,edi
	  }
	  break;
	 case 4:
	  _asm
	  {
	   mov eax,t_temp
	   mov edi,buff_addr
	   mov dword ptr window_b[edi],eax
	   lea edi,[edi+4]
	   mov buff_addr,edi
	  }
	  break;
	 }
	}
   }
  window_start++;
  window_start&=31;
 }
 int strt=m_iram[0xff4b];
 strt-=7;
 if(strt<160)
  for(int yu=0;yu<(160-strt)*dx_bits;yu++)
  {
   line_b[(strt+(nr_x&7))*dx_bits+yu+100]=window_b[yu];
   line_b_mask[(strt+(nr_x&7))*dx_bits+yu+100]=window_b_mask[yu];
  }
 }

 if((m_iram[0xff40]&2))
 {
  BYTE s16=0,zmp,pix_temp;
  signed int coordx_s,coordy_s,wx,wy,l_numb,sprite_la,flipx,address_w;
  if(m_iram[0xff40]&4)
   s16=1;
  WORD address;       
  for(int ioi=39;ioi>=0;ioi--)
  {
   address=ioi*4+0xfe00;
   wx=m_iram[address+1];
   wy=m_iram[address];
   coordx_s=wx-8;
   coordy_s=wy-16;
   attr=m_iram[address+3];
   if(gb_mode!=CGB)
   {
	   attr&=0xf0;
	   if(attr&0x10)
		attr|=1;
   }

   if(wx&&wy&&(wx<168)&&(coordy_s<=nr)&&(((!s16)&&(coordy_s>=(nr-7)))||(s16&&(coordy_s>=(nr-15)))))
   {
    l_numb=nr-coordy_s;
    if(m_iram[address+3]&64)
     if(s16)
      l_numb=15-l_numb;
     else
       l_numb=7-l_numb;
     if(!s16)
      sprite_la=0x8000+m_iram[address+2]*16+2*l_numb;
     else
      sprite_la=0x8000+(m_iram[address+2]&254)*16+2*l_numb;
     if(attr&32)
      flipx=1;
     else 
      flipx=0;
     if(attr&8)
	 {
	  w1=m_iram2[sprite_la++];
	  w2=m_iram2[sprite_la];
	 }
	 else
	 {
	  w1=m_iram[sprite_la++];
	  w2=m_iram[sprite_la];
	 }
     w3=(w2<<8)|w1;
     address_w=(coordx_s+(nr_x&7))*dx_bits+100;
     for(zmp=0;zmp<8;zmp++)
     {
      pix_temp=pix[w3][zmp][flipx];
      if(((!(attr&128))||((!line_b_mask[address_w])))&&pix_temp)
      {
	   t_temp=pal_dx_o[attr&7][pix_temp];	
	   switch(dx_bits)
	   {
	    case 2:
	     _asm
		  {
		   mov eax,t_temp
		   mov edi,address_w
		   mov word ptr line_b[edi],ax
		   lea edi,[edi+2]
		   mov address_w,edi
		  }
		  break;
		 case 3:
		  _asm
		  {
		   mov eax,t_temp
		   mov ebx,eax
		   shr eax,16
		   mov edi,address_w
		   mov line_b[edi],bl
		   mov line_b[edi+1],bh
		   mov line_b[edi+2],al
		   lea edi,[edi+3]
		   mov address_w,edi
		  }
		  break;
		 case 4:
		  _asm
		  {
		   mov eax,t_temp
		   mov edi,address_w
		   mov dword ptr line_b[edi],eax
		   lea edi,[edi+4]
		   mov address_w,edi
		  }
		  break;
		 }
	  }
	  else
	   address_w+=dx_bits;
	 }
    }
   }
 }
 buff_addr=(DWORD)(&line_b[100+(nr_x&7)*dx_bits]);
 DWORD ad2=(DWORD)(&dx_buffer[0]);
 DWORD aal=nr*dx_pitch;
 _asm
 {
  mov esi,buff_addr
  mov edi,ad2
  add edi,aal
  mov ecx,cmov
  cld
  rep movsd
 }
}